#include "math.h"
#include "extdll.h"
#include "enginecallback.h"
#include "util.h"
#include "cbase.h"
#include "player.h"
#include "weapons.h"
#include "entity_state.h"
#include "dll.h"
#include "engine.h"
#include "basemonster.h"

#include "skinmod.h"

int precached_models[256];
int precached_sounds[256];

modcmd_t ModCmd;
skin_t Skins[256];

int Features;
int SkinCount;

char FSNTFVersion[32];

float NextCvarCheck;
float timed_messages_next;

float NextEntityCheck;

int TeamAlly[4];

cvar_t fs_skins = {"fs_skins","1"};


void FSGameDLLInit()
{
	CVAR_REGISTER(&fs_skins);
}

int FSPlayerPreThink(edict_t *pEntity)
{
	// Don't do weird shit to non connected players
    if(FStrEq(STRING(pEntity->v.netname),"") || (!FStrEq(STRING(pEntity->v.classname),"player")))
		return 0;

	if(pEntity->v.deadflag)
	{
		Skins[ENTINDEX(pEntity)].DoneRespawnReset = 0;

	}
  	return 0;
}

int FSPlayerPostThink(edict_t *pEntity)
{

	return 0;
}

int FSDispatchKeyValue(edict_t *pEntity, KeyValueData *pkvd)
{
	return 0;
}

int FSDispatchThink(edict_t *pEntity)
{
	return 0;
}

int FSDispatchUse(edict_t *pEntity, edict_t *pOther)
{
    return 0;
}

int FSDispatchTouch(edict_t *pEntity, edict_t *pOther)
{
	return 0;
}

int FSDispatchBlocked(edict_t *pEntity, edict_t *pOther)
{
	return 0;
}


int FSClientCommand(edict_t *pEntity)
{
	if(Features & FEAT_ACTIVE)FSApplySkins(pEntity);
    return 0;
}

int FSClientPutInServer(edict_t *pEntity)
{
	return 0;
}


int FSDispatchSpawn(edict_t *pEntity)
{
	CBaseEntity *pCEntity;

	NextCvarCheck = gpGlobals->time;
    NextEntityCheck = gpGlobals->time;
	timed_messages_next = gpGlobals->time;

	if (FStrEq(STRING(pEntity->v.classname), "worldspawn"))
	{
	    Features = FEAT_NONE;

   		precached_models[0] = PRECACHE_MODEL("sprites/laserbeam.spr"); 
        precached_models[3] = PRECACHE_MODEL("sprites/lgtning.spr"); 
        precached_models[4] = PRECACHE_MODEL ("sprites/bubble.spr");
		FSLoadSkins();
		FSPrecache();
    }
    return 0;
}

int FSClientDisconnect(edict_t *pEntity)
{
		return 0;
}


void FSClientConnect( edict_t *pEntity, const char *pszName, const char *pszAddress, char szRejectReason[ 128 ]  )
{
	CLIENT_PRINTF( pEntity, print_console, "\n\nThis server is running AusIV's ReSkinning Mini-Mod version 2.0\nIt is available at www.tfcclandd.com/flipside\n");
}

int FSStartFrame(void)
{
	if(gpGlobals->time > NextCvarCheck)
    {
    	int OldFeatures = Features;
    	Features = FEAT_NONE;
		Features |= CVAR_GET_FLOAT("fs_skins") ? FEAT_ACTIVE : 0;
//	    Features |= CVAR_GET_FLOAT("ntf_feature_spychat") ? FEAT_SPYCHAT : 0;
    	NextCvarCheck = gpGlobals->time + 10;
    }

    if(gpGlobals->time > NextEntityCheck)
    {
    }
    
	return 0;
}
void FSPrecache(void)
{
	int precached_skin[50];
	int counter;
	char tmp[256]; 
    char seps[] = ":"; 
    char *token; 

	FILE *glyphfile;
#ifndef __linux__
    glyphfile = fopen("tfc\\fs_skins_precache.txt","rt");
#else
    glyphfile = fopen("tfc/fs_skins_precache.txt","rt");
#endif
    if(glyphfile)
    	ALERT(at_console, "{FS} File fs_skins_precache.txt found, loading skins.\n");
    else
    	ALERT(at_console, "{FS} File fs_skins_precache.txt not found, not loading skins.\n");
    if(glyphfile)
	{
		while (!feof(glyphfile) )  
		{ 
 			while(fgets(tmp, 100, glyphfile))
			{
    			if ((strncmp(tmp, "#", 1) != 0) && (strncmp(tmp, "//", 2) != 0) && (strlen(tmp) != 0)) 
				{ 
					precached_skin[counter] = PRECACHE_MODEL(tmp);
				}
				counter++;
			}
		}
	}
    if(glyphfile!=NULL) fclose(glyphfile);
    ALERT(at_console, "{FS} Precached %i skins.\n", counter);
}
void FSLoadSkins(void)
{
	char tmp[256]; 
    char seps[] = ":"; 
    char *token; 

	FILE *glyphfile;
#ifndef __linux__
    glyphfile = fopen("tfc\\fs_skins.txt","rt");
#else
    glyphfile = fopen("tfc/fs_skins.txt","rt");
#endif
    if(glyphfile)
    	ALERT(at_console, "{FS} File fs_skins.txt found, loading skins.\n");
    else
    	ALERT(at_console, "{FS} File fs_skins.txt not found, not loading skins.\n");
    SkinCount = 0;
    // Gotta keep the filename recorded in the array too because if the string is corrupted HL's model index gets all screwed.

    while (!feof(glyphfile) )  
	{ 
 		while(fgets(tmp, 100, glyphfile))
		{
    		if ((strncmp(tmp, "#", 1) != 0) && (strncmp(tmp, "//", 2) != 0) && (strlen(tmp) != 0)) 
            { 
            token = strtok( tmp, seps ); 
			strcpy(Skins[SkinCount].Name, token);
			token = strtok( NULL, seps );
			strcpy(Skins[SkinCount].FileName, token);
			token = strtok( NULL, seps );
			strcpy(Skins[SkinCount].SubModel, token);
			token = strtok( NULL, seps );
			Skins[SkinCount].WonId = atoi(token);
			}
    		SkinCount++;
		}
	}
    if(glyphfile!=NULL) fclose(glyphfile);
    ALERT(at_console, "{FS} Loaded %d skins.\n", SkinCount);
}
Vector GetColor(edict_t *pEntity)
{
	if(pEntity->v.team == 1)
	{
		return Vector(0, 0, 255);
	}
	else if(pEntity->v.team == 2)
	{
		return Vector(255, 0, 0);
	}
	else if(pEntity->v.team == 3)
	{
		return Vector(255, 255, 0);
	}
	else if(pEntity->v.team == 4)
	{
		return Vector(0, 255, 0);
	}
	else
	{
		return Vector (255, 255, 255);
	}
}
void FSApplySkins(edict_t *pEntity)
{
	if(FStrEq(Cmd_Argv(0), "skinlist"))
	{
		int gmsgMOTD = REG_USER_MSG( "MOTD", -1 );
		char chunk[256];
		sprintf(chunk, "The following skins are available:\n");
		MESSAGE_BEGIN( MSG_ONE, gmsgMOTD, NULL, pEntity );
			WRITE_BYTE(FALSE);	// FALSE means there is still more message to come
			WRITE_STRING( chunk );
		MESSAGE_END();
		for(int i=0; i<SkinCount; i++)
		{
			if((Skins[i].WonId == (signed)pfnGetPlayerWONId(pEntity)) || (Skins[i].WonId == 0))
			{
			//MOTD Box
			sprintf(chunk, "\"%s\"\n", Skins[i].Name);
			MESSAGE_BEGIN( MSG_ONE, gmsgMOTD, NULL, pEntity );
				WRITE_BYTE(FALSE);	
				WRITE_STRING( chunk );
			MESSAGE_END();
			}
		}
		sprintf(chunk, "\n");
		MESSAGE_BEGIN( MSG_ONE, gmsgMOTD, NULL, pEntity );
			WRITE_BYTE(TRUE);
			WRITE_STRING( chunk );
		MESSAGE_END();
	}
	if(FStrEq(Cmd_Argv(0), "applyskin"))
	{
		int replied = 0;
		for(int i=0; i<SkinCount; i++)
		{
			if(FStrEq(Cmd_Argv(1), Skins[i].Name))
			{
					if((Skins[i].WonId == (signed)pfnGetPlayerWONId(pEntity)) || (Skins[i].WonId == 0))
					{
							GameKeyValue(pEntity, "player", "replacement_model", Skins[i].FileName);
							GameKeyValue(pEntity, "player", "replacement_model_skin", Skins[i].SubModel);
							//This line doesn't do what it looks like it should. It actually makes the engine force the model to the one mentioned above.
							pfnSetClientKeyValue(ENTINDEX(pEntity), pfnGetInfoKeyBuffer( pEntity ), "model", Skins[i].FileName);
							
							CBaseEntity *pCPlayer = CBaseEntity::Instance(pEntity);
							pCPlayer->PrintTalk("> Skin applied.");
							replied = 1;
					}
					else
					{
						CBaseEntity *pCPlayer = CBaseEntity::Instance(pEntity);
						pCPlayer->PrintTalk("> This skin is reserved");
						replied = 1;
					}
			}
		}
		if(!replied)
		{
		CBaseEntity *pCPlayer = CBaseEntity::Instance(pEntity);
		pCPlayer->PrintTalk("> Skin not found");
		}
	}
}
